var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "te-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty('entries/' + path, value);
        Property.setFlag('entries/' + path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}


function getNewIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('entries');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function putActionParameter(idValue,oParameterObject) {
    
    for ( var iIndex = 0; iIndex < oParameterObject.actions.length; iIndex++) {
        var oSubobject = oParameterObject.actions[iIndex];
        storeSubParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type);
        switch (oSubobject.type) {
            case 'zone-scene':
                storeSubParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone);
                storeSubParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group);
                storeSubParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene);
                storeSubParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force);
            break;
            case 'device-scene':
                storeSubParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
                storeSubParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene);
                storeSubParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force);
            break;
            case 'device-value':
                storeSubParameter(idValue + '/actions/' + iIndex + '/value', oSubobject.value);
                storeSubParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
            break;
            case 'device-blink':
                storeSubParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
            break;
            case 'zone-blink':
                storeSubParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone);
                storeSubParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group);
            break;
            case 'custom-event':
                storeSubParameter(idValue + '/actions/' + iIndex + '/event', oSubobject.event);
            break;
            case 'url':
                storeSubParameter(idValue + '/actions/' + iIndex + '/url', oSubobject.url);
            break;
        }
    }    
}

function putRecurrenceParameter(idValue,oParameterObject) {
    if (oParameterObject.recurrence!=null) {
        storeSubParameter(idValue + '/time/recurrenceBase', oParameterObject.recurrence.recurrenceBase);
        if (oParameterObject.recurrence.recurrenceBase=='absolute') {
            for (var iIndex=0;iIndex<oParameterObject.recurrence.timeArray.length;iIndex++){
                storeSubParameter(idValue + '/time/date/' + iIndex , oParameterObject.recurrence.timeArray[iIndex]);
            }
        } else {
            for (var iIndex=0;iIndex<oParameterObject.recurrence.timeArray.length;iIndex++){
                storeSubParameter(idValue + '/time/recurrence/' + iIndex , oParameterObject.recurrence.timeArray[iIndex]);
            }
        }
    }
}

function putTimerParameter(idValue,oParameterObject) {
    if (oParameterObject.time!=null) {
        storeSubParameter(idValue + '/time/timeBase', oParameterObject.time.timeBase);
        storeSubParameter(idValue + '/time/offset', oParameterObject.time.offset);
        if (oParameterObject.time.limitAfter!=null)
            storeSubParameter(idValue + '/time/limitAfter', oParameterObject.time.limitAfter);
        if (oParameterObject.time.limitBefore!=null)
            storeSubParameter(idValue + '/time/limitBefore', oParameterObject.time.limitBefore);
    }
}

function storeValue(sValue) {
    try {
        var oParameterObject = JSON.parse(unescape(sValue));

        var idValue = null;
        if (oParameterObject.id != null)
            idValue = oParameterObject.id;
        else
            idValue = getNewIdValue();

        var baseNode = Property.getNode('entries');
        if (baseNode != null)
            baseNode.removeChild(idValue);

        storeSubParameter(idValue + '/name', oParameterObject.name);
        storeSubParameter(idValue + '/id', idValue);
        storeSubParameter(idValue+ '/conditions/enabled', true);

        putActionParameter(idValue,oParameterObject);
        putTimerParameter(idValue,oParameterObject);    
        putRecurrenceParameter(idValue,oParameterObject);
        Property.store();
        setOneEvent(Property.getNode('entries/' + idValue));
    } catch (e) {
        lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
            l.logln(i + ': ' + e[i]);
        }
    }
}

if (raisedEvent.name == 'timed-events.config') {
    lInfo.logln("TE-Config param action " + raisedEvent.parameter.actions);
    if (raisedEvent.parameter.actions == 'save') {
        lInfo.logln("TE-Config param value " + raisedEvent.parameter.value);       
        storeValue(raisedEvent.parameter.value);
        Property.store();   
        var evt = new Event("timed-events.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'enable') {
        lInfo.logln("TE-Config enable value " + raisedEvent.parameter.id);
        storeSubParameter(raisedEvent.parameter.id + '/conditions/enabled', true);
        Property.store();
        var evt = new Event("timed-events.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'disable') {
        lInfo.logln("TE-Config disable value " + raisedEvent.parameter.id);
        storeSubParameter(raisedEvent.parameter.id + '/conditions/enabled', false);
        Property.store();
        var evt = new Event("timed-events.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'delete') {
        lInfo.logln("TE-Config delete value " + raisedEvent.parameter.id);

        var baseNode = Property.getNode('entries');
        if (baseNode != null)
            baseNode.removeChild(raisedEvent.parameter.id);
        
        Property.store();
        var evt = new Event("timed-events.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'updateTimer') {
        lInfo.logln("TE-Config updateTrigger ");     
        queueAllTimedEvents();
    }
    if (raisedEvent.parameter.actions =='suntime-reschedule') {
        lInfo.logln("TE-Config suntime-reschedule "); 
        queueAllTimedEvents();
    }
} 